     Program Miniterminal;
     uses ml4bib ,crt;          (* Einbinden der Bibliotheks-Unit *)
     var
	task,b  : byte;    (* Task-Nummer, Dummy-Byte *)
	s	: string;  (* Zeichen-String *)
	err	: word;    (* Fehler-Code *)
        ch      : char;    (* Zeichen *)

     function fehler : boolean;
     begin
{      fehler := false;
       if (ml4_get_par_byte(task,7) <> 0) or      (* berprfen der Parameter 7 und 8 *)
          (ml4_get_par_byte(task,8) <> 0) then    (* auf mgliche Fehler *)
         fehler := true
       else
         fehler := false;
}
     end;

     begin
       clrscr;
       err:=ml4_init($380,0,0,0);  (* Initialisieren der Kommunikation PC - MODULAR-4 *)
       if err>0 then begin
         writeln('Initfehler: ',err);
         exit;
       end;
       task := 3;  (* Task-Nummer der Kommunikations-Programmm 22 *)
       ch := ' '; s := '';
       repeat
         if (length(s)>0) and                          (* Senden *)
            (ml4_get_par_byte(task,28) = 3) then       (* 1. Abfrage des Parameters 28 *)
           begin
             ml4_set_dat_pointer(task,0);              (* 2. Daten-Pointer auf Anfang Datenbereich setzen *)
             ml4_task_block_write(task,length(s),s[1]);(* 3. Zeichen per Task_Block_Write in Datenbereich schreiben *)
             ml4_set_par_word(task,29,length(s));      (* 4. Anzahl Zeichen in Parameter-Wort 29 angeben *)
             ml4_set_par_byte(task,28,1);              (* 5. Sendung starten *)
             s:='';                                    (* Eingelesenen String wieder lschen *)
           end;
                                                       (* Empfangen *)
         ml4_call_proc(task,16);                       (* 1. Prozedur 16 aufrufen *)
         if ml4_read=$f1 then                          (* 2. Antwort von Prozedur 16 analysieren *)
           begin                                       (* = $F1 : Zeichen empfangen *)
             b := ml4_read;                            (* 3. Tasknummer lesen *)
             write(char(ml4_read));                    (* 4. Zeichen lesen und auf Bildschirm schreiben *)
           end
         else                                          (* = $F2 : kein Zeichen empfangen *)
           b := ml4_read;
         if keypressed then begin                      (* Tastatureingabe *)
           ch := readkey;                              (* Eingabe-Zeichen lesen *)
           s := s + ch;                                (* und an String anhngen *)
         end;
       until (ch = #27) or fehler;
     end.