(* Letzte Bearbeitung : 03.09.1991 14:10 *)

(* Version 1D *)

(* Version fr Turbo-PASCAL *)

(* Kommunikation zweier COMxx - Schnittstellen :

   - die COMxx Schnittstellen mssen definiert werden mit MC4CONF.EXE:
     => Die Dateien CONFIGxx.ADD und MC4CONF.INS werden erzeugt
   - die Dateien CONFIGxx.ADD mssen bernommen werden in CONFIG.SYS
   - das Programm ML4LAB.EXE mu aufgerufen werden:

                  ML4LAB MC4CONF

     => Die Kommunikationsprogramme (.LAB Dateien) werden erzeugt

   - das System mu neu gestartet werden mit CTRL+ALT+DEL
   - die Schnittstellen mssen mit ML4MULT installiert und ggf.initialisiert
     werden:
                  ML4MULT MC4CONF

   - Start dieses Programms (s.a. Beschreibung MS-DOS Einheitentreiber *)


program test_sio;
uses
    crt,dos;

var
   regs : registers;
   fil : text; (* Input / Output - Dateien *)
   ch2,ch1 : char;          (* Zeichen *)
   kanal1,kanal2 : integer; (* DOS-Kanle *)
   COM5,COM6 : STRING[8];

begin
  clrscr;
  writeln('Senden der Zeichen dieser Datei ber die Schnittstelle COM5 und');
  writeln('Empfangen der Zeichen von der Schnittstelle COM6 und');
  writeln('Ausgabe auf den Bildschirm');
  writeln;
  assign(fil,'testsio1.pas');          (* ffnen der Text-Datei *)
  reset(fil);
  COM5 := 'COM5    ';                  (* Zuweisen der DOS-Namen *)
  COM6 := 'COM6    ';
  with regs do
    begin
      ax := $9000;                     (* Ermitteln der Kanal-Nr. fr COM5 *)
      ds := seg(COM5);
      si := ofs(COM5)+1;
      intr($14,regs);
      kanal1 := dx;
      ax := $9000;                     (* Ermitteln der Kanal-Nr. fr COM6 *)
      ds := seg(COM6);
      si := ofs(COM6)+1;
      intr($14,regs);
      kanal2 := dx;
    end;
  while not (eof(fil) or keypressed) do
    begin
      read(fil,ch1);                  (* Lesen der Zeichen aus der Text-Datei *)
      with regs do
        begin
          ax := $8800+ord(ch1);              (* Senden der Zeichen ber COM5 *)
          dx := kanal1;
          intr($14,regs);
          repeat
            ax := $8B00;
            dx := kanal2;
            intr($14,regs);
          until bx >= 1;

          ax := $8700;
          dx := kanal2;
          intr($14,regs);

          ch2 := chr(al);                (* Empfangen der Zeichen ber COM6 *)

          write(ch2);                     (* Schreiben auf den Bildschirm *)
        end;
    end;
  close(fil);                         (* Schlieen der Text-Datei *)
end.
