(* Letzte Bearbeitung : 03.09.1991   14:20 *)

(* Version 1D *)

(* Version fr Turbo-PASCAL *)

(* Kommunikation zweier COMxx - Schnittstellen :

   - die COMxx Schnittstellen mssen definiert werden mit MC4CONF.EXE:
     => Die Dateien CONFIGxx.ADD und MC4CONF.INS werden erzeugt
   - die Dateien CONFIGxx.ADD mssen bernommen werden in CONFIG.SYS
   - das Programm ML4LAB.EXE mu aufgerufen werden:

                  ML4LAB MC4CONF

     => Die Kommunikationsprogramme (.LAB Dateien) werden erzeugt

   - das System mu neu gestartet werden mit CTRL+ALT+DEL
   - die Schnittstellen mssen mit ML4MULT installiert und ggf.initialisiert
     werden:
                  ML4MULT MC4CONF

   - Start dieses Programms (s.a. Beschreibung MS-DOS Einheitentreiber *)


program test_sio;
uses
    crt,dos;

var
   regs : registers;
   fil : text; (* Input / Output - Dateien *)
   puffer1,puffer2 : array[1..8000] of char;
   i : integer;

begin
  clrscr;
  writeln('Senden der Zeichen dieser Datei ber die Schnittstelle COM5 und');
  writeln('Empfangen der Zeichen von der Schnittstelle COM6 und');
  writeln('Ausgabe auf den Bildschirm');
  writeln;
  assign(fil,'testsio2.pas');          (* ffnen der Text-Datei *)
  reset(fil);
  i := 0;
  while not (eof(fil) or keypressed) do
    begin
      inc(i);
      read(fil,puffer1[i]);                  (* Lesen der Zeichen aus der Text-Datei *)
    end;
  close(fil);                         (* Schlieen der Text-Datei *)
  with regs do
    begin
      ax := $8C00;
      dx := 4;
      intr($14,regs);
      if bx <> 0 then
        begin
          write(bx);readln;
        end;
      ax := $8E00;              (* Senden der Zeichen ber COM5 *)
      es := seg(puffer1);
      di := ofs(puffer1);
      bx := i;
      dx := 4;
      intr($14,regs);
      for i := 1 to bx do
        puffer2[i] := ' ';
      repeat
        ax := $8B00;
        dx := 5;
        intr($14,regs);
      until (bx = i) or keypressed;
      ax := $8D00;
      dx := 5;
      es := seg(puffer2);
      di := ofs(puffer2);
      intr($14,regs);
      for i := 1 to bx do
        begin
          write(puffer2[i]);                (* Empfangen der Zeichen ber COM6 *)
          if puffer2[i] <> puffer1[i] then
            begin
              writeln('Fehler: ',i,' ',puffer1[i],' ',puffer2[i]);readln;
            end;
        end;
    end;
end.
